# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_客户发放返利,2271,2271-6,sit,bs
主数据平台:后台运营系统客户发放返利查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取客户发放返利信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url5")
request_body = commonFuc().get_business_data(module, "payload5")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)


# 此函数用于当x为none时，进行空字符串替换
def func(x):
    if x is None:
        x = ""
        return x
    else:
        return x


# 生成一个随机数字，用于后续随机选择某一条客户发放返利信息
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取客户发放返利列表中某一条返利信息
customer_code = result["data"]["list"][rebate_random]["customerCode"]
telephone = result["data"]["list"][rebate_random]["telephone"]
company_name = result["data"]["list"][rebate_random]["companyName"]
rebate_id = result["data"]["list"][rebate_random]["rebateId"]
rebate_name = result["data"]["list"][rebate_random]["rebateName"]
relevance_name = result["data"]["list"][rebate_random]["relevanceName"]

# 第三步进行条件查询验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url6")
request_body = commonFuc().get_business_data(module, "payload6", customer_code, telephone, company_name,
                                             rebate_id, rebate_name, relevance_name)
"""

 场景: 验证客户发放返利列表查询条件是否可以正常使用
 用例名称：列表查询条件验证_客户发放返利
 输出：{"customerCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 获取查询结果中返利明细对应的客户编号
result = {"customerCode": result["data"]["list"][0]["customerCode"]}
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict6", customer_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

